commit 9a3440218e29a4a388da7de9033bae8734b95268
Author: Andrew Beekhof <andrew@beekhof.net>
Date:   Tue Jul 21 19:30:19 2015 +1000

    Fix: pengine: Correctly bypass fencing for resources that do not require it

diff --git a/pengine/native.c b/pengine/native.c
index b93f8da..7d5f602 100644
--- a/pengine/native.c
+++ b/pengine/native.c
@@ -2817,8 +2817,7 @@ native_create_probe(resource_t * rsc, node_t * node, action_t * complete,
 }
 
 static void
-native_start_constraints(resource_t * rsc, action_t * stonith_op, gboolean is_stonith,
-                         pe_working_set_t * data_set)
+native_start_constraints(resource_t * rsc, action_t * stonith_op, pe_working_set_t * data_set)
 {
     node_t *target = stonith_op ? stonith_op->node : NULL;
 
@@ -2893,14 +2892,24 @@ find_fence_target_node_actions(GListPtr search_list, const char *key, node_t *fe
 }
 
 static void
-native_stop_constraints(resource_t * rsc, action_t * stonith_op, gboolean is_stonith,
-                        pe_working_set_t * data_set)
+native_stop_constraints(resource_t * rsc, action_t * stonith_op, pe_working_set_t * data_set)
 {
     char *key = NULL;
     GListPtr gIter = NULL;
     GListPtr action_list = NULL;
+
+    action_t *start = NULL;
     resource_t *top = uber_parent(rsc);
 
+    key = start_key(rsc);
+    action_list = find_actions(rsc->actions, key, NULL);
+    if(action_list) {
+        start = action_list->data;
+    }
+
+    g_list_free(action_list);
+    free(key);
+
     key = stop_key(rsc);
     action_list = find_fence_target_node_actions(rsc->actions, key, stonith_op->node, data_set);
     free(key);
@@ -2932,7 +2941,7 @@ native_stop_constraints(resource_t * rsc, action_t * stonith_op, gboolean is_sto
         update_action_flags(action, pe_action_runnable);
         update_action_flags(action, pe_action_implied_by_stonith);
 
-        {
+        if(start == NULL || start->needs > rsc_req_quorum) {
             enum pe_ordering flags = pe_order_optional;
             action_t *parent_stop = find_first_action(top->actions, NULL, RSC_STOP, NULL);
 
@@ -3032,7 +3041,8 @@ native_stop_constraints(resource_t * rsc, action_t * stonith_op, gboolean is_sto
             crm_trace("here - 1");
             update_action_flags(action, pe_action_pseudo);
             update_action_flags(action, pe_action_runnable);
-            if (is_stonith == FALSE) {
+
+            if (start == NULL || start->needs > rsc_req_quorum) {
                 order_actions(stonith_op, action, pe_order_preserve|pe_order_optional);
             }
         }
@@ -3044,8 +3054,6 @@ native_stop_constraints(resource_t * rsc, action_t * stonith_op, gboolean is_sto
 void
 rsc_stonith_ordering(resource_t * rsc, action_t * stonith_op, pe_working_set_t * data_set)
 {
-    gboolean is_stonith = FALSE;
-
     if (rsc->children) {
         GListPtr gIter = NULL;
 
@@ -3063,11 +3071,11 @@ rsc_stonith_ordering(resource_t * rsc, action_t * stonith_op, pe_working_set_t *
     }
 
     /* Start constraints */
-    native_start_constraints(rsc, stonith_op, is_stonith, data_set);
+    native_start_constraints(rsc, stonith_op, data_set);
 
     /* Stop constraints */
     if (stonith_op) {
-        native_stop_constraints(rsc, stonith_op, is_stonith, data_set);
+        native_stop_constraints(rsc, stonith_op, data_set);
     }
 }
 
diff --git a/pengine/test10/bug-5186-partial-migrate.dot b/pengine/test10/bug-5186-partial-migrate.dot
index 033d41d..65f5616 100644
--- a/pengine/test10/bug-5186-partial-migrate.dot
+++ b/pengine/test10/bug-5186-partial-migrate.dot
@@ -66,13 +66,10 @@
 "stonith 'reboot' bl460g1n7" -> "clnDiskd1_stop_0" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "clnDiskd2_stop_0" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "clnPing_stop_0" [ style = bold]
-"stonith 'reboot' bl460g1n7" -> "grpStonith8_stop_0" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "prmDiskd1_stop_0 bl460g1n7" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "prmDiskd2_stop_0 bl460g1n7" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "prmDummy_stop_0 bl460g1n7" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "prmPing_stop_0 bl460g1n7" [ style = bold]
-"stonith 'reboot' bl460g1n7" -> "prmStonith8-1_stop_0 bl460g1n7" [ style = bold]
-"stonith 'reboot' bl460g1n7" -> "prmStonith8-2_stop_0 bl460g1n7" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "prmVM2_stop_0 bl460g1n7" [ style = bold]
 "stonith 'reboot' bl460g1n7" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' bl460g1n7" [ style=bold color="green" fontcolor="black"]
diff --git a/pengine/test10/bug-5186-partial-migrate.exp b/pengine/test10/bug-5186-partial-migrate.exp
index 216d962..bc058ea 100644
--- a/pengine/test10/bug-5186-partial-migrate.exp
+++ b/pengine/test10/bug-5186-partial-migrate.exp
@@ -104,11 +104,7 @@
         <attributes CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="75" operation="stonith" operation_key="stonith-bl460g1n7-reboot" on_node="bl460g1n7" on_node_uuid="3232261593"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="8">
     <action_set>
@@ -182,9 +178,6 @@
       <trigger>
         <pseudo_event id="45" operation="stop" operation_key="grpStonith8_stop_0"/>
       </trigger>
-      <trigger>
-        <crm_event id="75" operation="stonith" operation_key="stonith-bl460g1n7-reboot" on_node="bl460g1n7" on_node_uuid="3232261593"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
@@ -229,9 +222,6 @@
       <trigger>
         <pseudo_event id="45" operation="stop" operation_key="grpStonith8_stop_0"/>
       </trigger>
-      <trigger>
-        <crm_event id="75" operation="stonith" operation_key="stonith-bl460g1n7-reboot" on_node="bl460g1n7" on_node_uuid="3232261593"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="16">
diff --git a/pengine/test10/bug-5186-partial-migrate.summary b/pengine/test10/bug-5186-partial-migrate.summary
index f848c97..5e62a23 100644
--- a/pengine/test10/bug-5186-partial-migrate.summary
+++ b/pengine/test10/bug-5186-partial-migrate.summary
@@ -35,18 +35,22 @@ Transition Summary:
 
 Executing cluster transition:
  * Resource action: prmVM2          stop on bl460g1n6
+ * Pseudo action:   grpStonith8_stop_0
+ * Pseudo action:   prmStonith8-2_stop_0
  * Fencing bl460g1n7 (reboot)
  * Pseudo action:   stonith_complete
  * Pseudo action:   prmDummy_stop_0
  * Pseudo action:   prmVM2_stop_0
- * Pseudo action:   grpStonith8_stop_0
- * Pseudo action:   prmStonith8-2_stop_0
+ * Pseudo action:   prmStonith8-1_stop_0
  * Pseudo action:   clnDiskd1_stop_0
  * Pseudo action:   clnDiskd2_stop_0
  * Pseudo action:   clnPing_stop_0
  * Resource action: prmDummy        start on bl460g1n6
  * Resource action: prmVM2          start on bl460g1n8
- * Pseudo action:   prmStonith8-1_stop_0
+ * Pseudo action:   grpStonith8_stopped_0
+ * Pseudo action:   grpStonith8_start_0
+ * Resource action: prmStonith8-1   start on bl460g1n6
+ * Resource action: prmStonith8-2   start on bl460g1n6
  * Pseudo action:   prmDiskd1_stop_0
  * Pseudo action:   clnDiskd1_stopped_0
  * Pseudo action:   prmDiskd2_stop_0
@@ -55,10 +59,6 @@ Executing cluster transition:
  * Pseudo action:   clnPing_stopped_0
  * Pseudo action:   all_stopped
  * Resource action: prmVM2          monitor=10000 on bl460g1n8
- * Pseudo action:   grpStonith8_stopped_0
- * Pseudo action:   grpStonith8_start_0
- * Resource action: prmStonith8-1   start on bl460g1n6
- * Resource action: prmStonith8-2   start on bl460g1n6
  * Pseudo action:   grpStonith8_running_0
  * Resource action: prmStonith8-1   monitor=10000 on bl460g1n6
  * Resource action: prmStonith8-2   monitor=3600000 on bl460g1n6
diff --git a/pengine/test10/bug-lf-2551.dot b/pengine/test10/bug-lf-2551.dot
index ed80e15..18bca44 100644
--- a/pengine/test10/bug-lf-2551.dot
+++ b/pengine/test10/bug-lf-2551.dot
@@ -56,7 +56,6 @@ digraph "g" {
 "stonith 'reboot' hex-9" -> "cmirrord:3_stop_0 hex-9" [ style = bold]
 "stonith 'reboot' hex-9" -> "dlm:3_stop_0 hex-9" [ style = bold]
 "stonith 'reboot' hex-9" -> "dummy1_stop_0 hex-9" [ style = bold]
-"stonith 'reboot' hex-9" -> "fencing-sbd_stop_0 hex-9" [ style = bold]
 "stonith 'reboot' hex-9" -> "o2cb:3_stop_0 hex-9" [ style = bold]
 "stonith 'reboot' hex-9" -> "ocfs2-1:3_stop_0 hex-9" [ style = bold]
 "stonith 'reboot' hex-9" -> "stonith_complete" [ style = bold]
diff --git a/pengine/test10/bug-lf-2551.exp b/pengine/test10/bug-lf-2551.exp
index 0af9010..d6266e1 100644
--- a/pengine/test10/bug-lf-2551.exp
+++ b/pengine/test10/bug-lf-2551.exp
@@ -18,11 +18,7 @@
         <attributes CRM_meta_record_pending="false" CRM_meta_timeout="240000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000250000"/>
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="249" operation="stonith" operation_key="stonith-hex-9-reboot" on_node="hex-9" on_node_uuid="hex-9"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="2">
     <action_set>
diff --git a/pengine/test10/bug-lf-2551.summary b/pengine/test10/bug-lf-2551.summary
index f8d861c..158eb73 100644
--- a/pengine/test10/bug-lf-2551.summary
+++ b/pengine/test10/bug-lf-2551.summary
@@ -107,6 +107,7 @@ Transition Summary:
  * Stop    vm-61	(hex-9)
 
 Executing cluster transition:
+ * Pseudo action:   fencing-sbd_stop_0
  * Resource action: dummy1          monitor=300000 on hex-8
  * Resource action: dummy1          monitor=300000 on hex-7
  * Fencing hex-9 (reboot)
@@ -114,7 +115,7 @@ Executing cluster transition:
  * Pseudo action:   load_stopped_hex-8
  * Pseudo action:   load_stopped_hex-7
  * Pseudo action:   load_stopped_hex-0
- * Pseudo action:   fencing-sbd_stop_0
+ * Resource action: fencing-sbd     start on hex-0
  * Pseudo action:   dummy1_stop_0
  * Pseudo action:   vm-03_stop_0
  * Pseudo action:   vm-06_stop_0
@@ -133,7 +134,6 @@ Executing cluster transition:
  * Pseudo action:   vm-57_stop_0
  * Pseudo action:   vm-61_stop_0
  * Pseudo action:   load_stopped_hex-9
- * Resource action: fencing-sbd     start on hex-0
  * Resource action: dummy1          start on hex-0
  * Pseudo action:   base-clone_stop_0
  * Resource action: dummy1          monitor=30000 on hex-0
diff --git a/pengine/test10/stonith-1.dot b/pengine/test10/stonith-1.dot
index d64edcf..3814ac9 100644
--- a/pengine/test10/stonith-1.dot
+++ b/pengine/test10/stonith-1.dot
@@ -88,8 +88,6 @@ digraph "g" {
 "rsc_sles-3_stop_0 sles-3" -> "rsc_sles-3_start_0 sles-4" [ style = bold]
 "rsc_sles-3_stop_0 sles-3" [ style=bold color="green" fontcolor="orange" ]
 "rsc_sles-4_monitor_5000 sles-4" [ style=bold color="green" fontcolor="black" ]
-"stonith 'reboot' sles-3" -> "DoFencing_stop_0" [ style = bold]
-"stonith 'reboot' sles-3" -> "child_DoFencing:2_stop_0 sles-3" [ style = bold]
 "stonith 'reboot' sles-3" -> "master_rsc_1_stop_0" [ style = bold]
 "stonith 'reboot' sles-3" -> "migrator_stop_0 sles-3" [ style = bold]
 "stonith 'reboot' sles-3" -> "ocf_msdummy:2_stop_0 sles-3" [ style = bold]
diff --git a/pengine/test10/stonith-1.exp b/pengine/test10/stonith-1.exp
index 4d58afa..40b22cb 100644
--- a/pengine/test10/stonith-1.exp
+++ b/pengine/test10/stonith-1.exp
@@ -210,9 +210,6 @@
       <trigger>
         <pseudo_event id="47" operation="stop" operation_key="DoFencing_stop_0"/>
       </trigger>
-      <trigger>
-        <crm_event id="72" operation="stonith" operation_key="stonith-sles-3-reboot" on_node="sles-3" on_node_uuid="2298606a-6a8c-499a-9d25-76242f7006ec"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="17" priority="1000000">
@@ -236,11 +233,7 @@
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="10000" />
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="72" operation="stonith" operation_key="stonith-sles-3-reboot" on_node="sles-3" on_node_uuid="2298606a-6a8c-499a-9d25-76242f7006ec"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="19" priority="1000000">
     <action_set>
diff --git a/pengine/test10/stonith-1.summary b/pengine/test10/stonith-1.summary
index ef904fe..e99bb5e 100644
--- a/pengine/test10/stonith-1.summary
+++ b/pengine/test10/stonith-1.summary
@@ -45,20 +45,22 @@ Executing cluster transition:
  * Resource action: lsb_dummy       monitor=5000 on sles-2
  * Resource action: rsc_sles-2      monitor=5000 on sles-2
  * Resource action: rsc_sles-4      monitor=5000 on sles-4
+ * Pseudo action:   DoFencing_stop_0
  * Fencing sles-3 (reboot)
  * Pseudo action:   stonith_complete
  * Resource action: r192.168.100.183 start on sles-1
  * Pseudo action:   migrator_stop_0
  * Pseudo action:   rsc_sles-3_stop_0
- * Pseudo action:   DoFencing_stop_0
+ * Pseudo action:   child_DoFencing:2_stop_0
+ * Pseudo action:   DoFencing_stopped_0
+ * Pseudo action:   DoFencing_start_0
  * Pseudo action:   master_rsc_1_stop_0
  * Pseudo action:   group-1_running_0
  * Resource action: r192.168.100.183 monitor=5000 on sles-1
  * Resource action: migrator        start on sles-4
  * Resource action: rsc_sles-3      start on sles-4
- * Pseudo action:   child_DoFencing:2_stop_0
- * Pseudo action:   DoFencing_stopped_0
- * Pseudo action:   DoFencing_start_0
+ * Resource action: child_DoFencing:2 start on sles-4
+ * Pseudo action:   DoFencing_running_0
  * Pseudo action:   ocf_msdummy:2_stop_0
  * Pseudo action:   ocf_msdummy:5_stop_0
  * Pseudo action:   master_rsc_1_stopped_0
@@ -66,8 +68,7 @@ Executing cluster transition:
  * Pseudo action:   all_stopped
  * Resource action: migrator        monitor=10000 on sles-4
  * Resource action: rsc_sles-3      monitor=5000 on sles-4
- * Resource action: child_DoFencing:2 start on sles-4
- * Pseudo action:   DoFencing_running_0
+ * Resource action: child_DoFencing:2 monitor=60000 on sles-4
  * Resource action: ocf_msdummy:0   start on sles-4
  * Resource action: ocf_msdummy:1   start on sles-1
  * Resource action: ocf_msdummy:2   start on sles-2
@@ -75,7 +76,6 @@ Executing cluster transition:
  * Resource action: ocf_msdummy:4   start on sles-1
  * Resource action: ocf_msdummy:5   start on sles-2
  * Pseudo action:   master_rsc_1_running_0
- * Resource action: child_DoFencing:2 monitor=60000 on sles-4
  * Resource action: ocf_msdummy:0   monitor=5000 on sles-4
  * Resource action: ocf_msdummy:1   monitor=5000 on sles-1
  * Resource action: ocf_msdummy:2   monitor=5000 on sles-2
diff --git a/pengine/test10/ticket-master-21.dot b/pengine/test10/ticket-master-21.dot
index 60386a8..3f94948 100644
--- a/pengine/test10/ticket-master-21.dot
+++ b/pengine/test10/ticket-master-21.dot
@@ -23,7 +23,6 @@ digraph "g" {
 "stonith 'reboot' node1" -> "ms1_stop_0" [ style = bold]
 "stonith 'reboot' node1" -> "rsc1:1_demote_0 node1" [ style = bold]
 "stonith 'reboot' node1" -> "rsc1:1_stop_0 node1" [ style = bold]
-"stonith 'reboot' node1" -> "rsc_stonith_stop_0 node1" [ style = bold]
 "stonith 'reboot' node1" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' node1" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
diff --git a/pengine/test10/ticket-master-21.exp b/pengine/test10/ticket-master-21.exp
index cc8df2f..c32bac5 100644
--- a/pengine/test10/ticket-master-21.exp
+++ b/pengine/test10/ticket-master-21.exp
@@ -18,11 +18,7 @@
         <attributes CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="21" operation="stonith" operation_key="stonith-node1-reboot" on_node="node1" on_node_uuid="node1"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="2">
     <action_set>
diff --git a/pengine/test10/ticket-master-21.summary b/pengine/test10/ticket-master-21.summary
index 64a9cbe..b228696 100644
--- a/pengine/test10/ticket-master-21.summary
+++ b/pengine/test10/ticket-master-21.summary
@@ -12,14 +12,14 @@ Transition Summary:
  * Demote  rsc1:0	(Master -> Stopped node1)
 
 Executing cluster transition:
+ * Pseudo action:   rsc_stonith_stop_0
  * Pseudo action:   ms1_demote_0
  * Fencing node1 (reboot)
  * Pseudo action:   stonith_complete
- * Pseudo action:   rsc_stonith_stop_0
+ * Resource action: rsc_stonith     start on node2
  * Pseudo action:   rsc1:1_demote_0
  * Pseudo action:   ms1_demoted_0
  * Pseudo action:   ms1_stop_0
- * Resource action: rsc_stonith     start on node2
  * Pseudo action:   rsc1:1_stop_0
  * Pseudo action:   ms1_stopped_0
  * Pseudo action:   all_stopped
diff --git a/pengine/test10/ticket-master-9.dot b/pengine/test10/ticket-master-9.dot
index 3a29836..c648feb 100644
--- a/pengine/test10/ticket-master-9.dot
+++ b/pengine/test10/ticket-master-9.dot
@@ -23,7 +23,6 @@ digraph "g" {
 "stonith 'reboot' node1" -> "ms1_stop_0" [ style = bold]
 "stonith 'reboot' node1" -> "rsc1:1_demote_0 node1" [ style = bold]
 "stonith 'reboot' node1" -> "rsc1:1_stop_0 node1" [ style = bold]
-"stonith 'reboot' node1" -> "rsc_stonith_stop_0 node1" [ style = bold]
 "stonith 'reboot' node1" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' node1" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
diff --git a/pengine/test10/ticket-master-9.exp b/pengine/test10/ticket-master-9.exp
index cc8df2f..c32bac5 100644
--- a/pengine/test10/ticket-master-9.exp
+++ b/pengine/test10/ticket-master-9.exp
@@ -18,11 +18,7 @@
         <attributes CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="21" operation="stonith" operation_key="stonith-node1-reboot" on_node="node1" on_node_uuid="node1"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="2">
     <action_set>
diff --git a/pengine/test10/ticket-master-9.summary b/pengine/test10/ticket-master-9.summary
index 64a9cbe..b228696 100644
--- a/pengine/test10/ticket-master-9.summary
+++ b/pengine/test10/ticket-master-9.summary
@@ -12,14 +12,14 @@ Transition Summary:
  * Demote  rsc1:0	(Master -> Stopped node1)
 
 Executing cluster transition:
+ * Pseudo action:   rsc_stonith_stop_0
  * Pseudo action:   ms1_demote_0
  * Fencing node1 (reboot)
  * Pseudo action:   stonith_complete
- * Pseudo action:   rsc_stonith_stop_0
+ * Resource action: rsc_stonith     start on node2
  * Pseudo action:   rsc1:1_demote_0
  * Pseudo action:   ms1_demoted_0
  * Pseudo action:   ms1_stop_0
- * Resource action: rsc_stonith     start on node2
  * Pseudo action:   rsc1:1_stop_0
  * Pseudo action:   ms1_stopped_0
  * Pseudo action:   all_stopped
diff --git a/pengine/test10/whitebox-imply-stop-on-fence.dot b/pengine/test10/whitebox-imply-stop-on-fence.dot
index 66700b8..b3fd40b 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.dot
+++ b/pengine/test10/whitebox-imply-stop-on-fence.dot
@@ -69,7 +69,6 @@
 "stonith 'reboot' kiff-01" -> "clvmd_stop_0 kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" -> "dlm-clone_stop_0" [ style = bold]
 "stonith 'reboot' kiff-01" -> "dlm_stop_0 kiff-01" [ style = bold]
-"stonith 'reboot' kiff-01" -> "fence-kiff-02_stop_0 kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" -> "lxc-01_kiff-01_stop_0 kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" -> "lxc-02_kiff-01_stop_0 kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" -> "shared0-clone_stop_0" [ style = bold]
diff --git a/pengine/test10/whitebox-imply-stop-on-fence.exp b/pengine/test10/whitebox-imply-stop-on-fence.exp
index d13c25f..4a3e757 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.exp
+++ b/pengine/test10/whitebox-imply-stop-on-fence.exp
@@ -31,11 +31,7 @@
         <attributes CRM_meta_timeout="20000" action="reboot"  ipaddr="kiff-02-ilo" login="admin" passwd="admin" pcmk_host_check="static-list" pcmk_host_list="kiff-02"/>
       </pseudo_event>
     </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="63" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
-      </trigger>
-    </inputs>
+    <inputs/>
   </synapse>
   <synapse id="3">
     <action_set>
diff --git a/pengine/test10/whitebox-imply-stop-on-fence.summary b/pengine/test10/whitebox-imply-stop-on-fence.summary
index 3bb1572..3ee9570 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.summary
+++ b/pengine/test10/whitebox-imply-stop-on-fence.summary
@@ -36,16 +36,16 @@ Transition Summary:
  * Move    lxc-02_kiff-01	(Started kiff-01 -> kiff-02)
 
 Executing cluster transition:
+ * Pseudo action:   fence-kiff-02_stop_0
  * Fencing kiff-01 (reboot)
  * Pseudo action:   stonith_complete
- * Pseudo action:   fence-kiff-02_stop_0
+ * Resource action: fence-kiff-02   start on kiff-02
  * Pseudo action:   vm-fs_stop_0
  * Pseudo action:   lxc-01_kiff-01_stop_0
  * Pseudo action:   lxc-02_kiff-01_stop_0
- * Resource action: fence-kiff-02   start on kiff-02
+ * Resource action: fence-kiff-02   monitor=60000 on kiff-02
  * Pseudo action:   R-lxc-01_kiff-01_stop_0
  * Pseudo action:   R-lxc-02_kiff-01_stop_0
- * Resource action: fence-kiff-02   monitor=60000 on kiff-02
  * Pseudo action:   shared0-clone_stop_0
  * Resource action: R-lxc-01_kiff-01 start on kiff-02
  * Resource action: R-lxc-02_kiff-01 start on kiff-02