commit 2bdc934ae05ad9f91ab0c11d28e38ecf264d7d1a
Author: David Vossel <dvossel@redhat.com>
Date:   Fri Jun 12 18:04:24 2015 -0400

    Low: pengine: regression test update for stonith pengine fix

diff --git a/pengine/test10/remote-fence-unclean.exp b/pengine/test10/remote-fence-unclean.exp
index 9b1e327..3c2858d 100644
--- a/pengine/test10/remote-fence-unclean.exp
+++ b/pengine/test10/remote-fence-unclean.exp
@@ -74,7 +74,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1" router_node="18node1"/>
+        <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -156,7 +156,7 @@
   </synapse>
   <synapse id="12">
     <action_set>
-      <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1" router_node="18node1">
+      <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1">
         <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_probe_complete="true" CRM_meta_stonith_action="reboot" />
       </crm_event>
     </action_set>
@@ -170,7 +170,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1" router_node="18node1"/>
+        <crm_event id="28" operation="stonith" operation_key="stonith-remote1-reboot" on_node="remote1" on_node_uuid="remote1"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/remote-recover-fail.exp b/pengine/test10/remote-recover-fail.exp
index dee4acf..8196560 100644
--- a/pengine/test10/remote-recover-fail.exp
+++ b/pengine/test10/remote-recover-fail.exp
@@ -100,7 +100,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto2"/>
+        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4"/>
       </trigger>
     </inputs>
   </synapse>
@@ -159,13 +159,13 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto2"/>
+        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
     <action_set>
-      <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto2">
+      <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4">
         <attributes CRM_meta_on_node="rhel7-auto4" CRM_meta_on_node_uuid="rhel7-auto4" CRM_meta_probe_complete="true" CRM_meta_stonith_action="reboot" />
       </crm_event>
     </action_set>
@@ -179,7 +179,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto2"/>
+        <crm_event id="30" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/remote-unclean2.exp b/pengine/test10/remote-unclean2.exp
index 10d65ee..6aa6b35 100644
--- a/pengine/test10/remote-unclean2.exp
+++ b/pengine/test10/remote-unclean2.exp
@@ -39,7 +39,7 @@
   </synapse>
   <synapse id="3">
     <action_set>
-      <crm_event id="14" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto1">
+      <crm_event id="14" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4">
         <attributes CRM_meta_on_node="rhel7-auto4" CRM_meta_on_node_uuid="rhel7-auto4" CRM_meta_probe_complete="true" CRM_meta_stonith_action="reboot" />
       </crm_event>
     </action_set>
@@ -53,7 +53,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="14" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4" router_node="rhel7-auto1"/>
+        <crm_event id="14" operation="stonith" operation_key="stonith-rhel7-auto4-reboot" on_node="rhel7-auto4" on_node_uuid="rhel7-auto4"/>
       </trigger>
     </inputs>
   </synapse>